import { Board, GameEnd, Move, ResolvedGameState } from "./type";
import { Coordinate } from "./coordinate";
import { Side } from "./side";
export { Side, opponentOf } from "./side";
export * from "./type";
export { can_see } from "./can_see";
export { can_move, throws_if_uncastlable, throws_if_unkumalable, entry_is_forbidden } from "./piece_phase";
export { displayCoord, ShogiColumnName, ShogiRowName, Coordinate, coordEq } from "./coordinate";
export declare const get_initial_state: (who_goes_first: Side) => ResolvedGameState;
export declare function can_place_stone(board: Readonly<Board>, side: Side, stone_to: Coordinate): boolean;
export declare function main(moves: Move[]): ResolvedGameState | GameEnd;
export declare function from_custom_state(moves: Move[], initial_state: ResolvedGameState): ResolvedGameState | GameEnd;
