import { Board, PiecePhaseMove, PiecePhasePlayed, ResolvedGameState, ChessProfession, KingProfession, ShogiProfession, Profession } from "./type";
import { Coordinate } from "./coordinate";
import { Side } from "./side";
export declare function entry_is_forbidden(prof: Profession, side: Side, to: Coordinate): boolean;
export declare function throws_if_unkumalable(board: Readonly<Board>, o: {
    from: Coordinate;
    to: Coordinate;
}): {
    king: {
        type: "王";
        side: Side;
        prof: KingProfession;
        has_moved_only_once: boolean;
        never_moved: boolean;
    };
    lance: {
        type: "しょ";
        side: Side;
        prof: ShogiProfession;
        can_kumal: boolean;
    };
};
/**
 * Resolved な状態に駒フェイズを適用。省略された情報を復元しながら適用しなきゃいけないので、かなりしんどい。
 * @param old 呼び出し後に破壊されている可能性があるので、後で使いたいならディープコピーしておくこと。
 * @param o
 */
export declare function play_piece_phase(old: ResolvedGameState, o: Readonly<PiecePhaseMove>): PiecePhasePlayed;
/**
 * `o.from` に駒があってその駒が `o.to` へと動く余地があるかどうかを返す。`o.to` が味方の駒で埋まっていたら false だし、ポーンの斜め前に敵駒がないなら斜め前は false となる。
 *  Checks whether there is a piece at `o.from` which can move to `o.to`. When `o.to` is occupied by an ally, this function returns false,
 *  and when there is no enemy piece diagonal to pawn, this function returns false for the diagonal direction.
 * @param board
 * @param o
 * @returns
 */
export declare function can_move(board: Readonly<Board>, o: {
    from: Coordinate;
    to: Coordinate;
}): boolean | "en passant";
export declare function throws_if_uncastlable(board: Readonly<Board>, o: {
    from: Coordinate;
    to: Coordinate;
}): {
    coord_that_king_passes_through: Coordinate;
    rook: {
        type: "ス";
        side: Side;
        prof: ChessProfession;
        never_moved: boolean;
    };
    rook_coord: Coordinate;
    king: {
        type: "王";
        side: Side;
        prof: KingProfession;
        has_moved_only_once: boolean;
        never_moved: boolean;
    };
};
